#ifndef TIMESERVER_H
#define TIMESERVER_H

/*
 *  Requires 4 UDP sockets (DAYTIME, TIME, NTP, NBNS) and 3 TCP sockets (DAYTIME, TIME, NETBIOS)
 */

#ifndef DAYTIME_PORT
#define DAYTIME_PORT 13
#endif
#ifndef TIME_PORT
#define TIME_PORT 37
#endif
#ifndef NTP_PORT
#define NTP_PORT 123
#endif
#ifndef NBNS_PORT
#define NBNS_PORT 137
#endif
#ifndef NETBIOS_PORT
#define NETBIOS_PORT 139
#endif

#define ICMP_TIMESTAMP 13
#define ICMP_TIMESTAMP_REPLY 14

/* Insert the following just before the call to ICMPPut() in stacktsk.c:

                #ifdef TIMESERVER_ICMP_REPLY
                TIMESERVER_ICMP_REPLY
                #endif
*/
#define TIMESERVER_ICMP_REPLY                          \
  if (type.ICMPCode == ICMP_TIMESTAMP)                 \
  {                                                    \
    int32 v;                                           \
    int16 cyr, m;                                      \
    int8 mo, dy, hr, mn, sc;                           \
    get_datetime(cyr, mo, dy, hr, mn, sc, m);          \
    v = (_mul(_mul(hr, 60) + mn, 60) + sc) * 1000 + m; \
    dataCount += 8;                                    \
    data[4] = data[ 8] = make8(v, 3);                  \
    data[5] = data[ 9] = make8(v, 2);                  \
    data[6] = data[10] = make8(v, 1);                  \
    data[7] = data[11] = make8(v, 0);                  \
    type.ICMPCode = ICMP_TIMESTAMP_REPLY;              \
    status_led2 = 100;                                 \
  }

int32 TimeServerLastSync;
int1  TimeServerHasSync;
// extra 'x' to allow insert of degree symbol
char TimeServerLatitude[12]; // "x9999.99999"
char TimeServerLatHemi;
char TimeServerLongitude[13]; // "x99999.99999"
char TimeServerLongHemi;
int8 sat_id[12];
int8 sat_elevation[12]; // 0..90
int16 sat_azimuth[12]; // 0..359
int8 sat_dbm[12]; // 0..99

void TimeServerInit(void);
void TimeServerTask(void);

#endif /* TIMESERVER_H */
